# CpuHeadroomParams

Added in[API level 36](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)  
Summary:[Nested Classes](https://developer.android.com/reference/android/os/CpuHeadroomParams#nestedclasses)\|[Constants](https://developer.android.com/reference/android/os/CpuHeadroomParams#constants)\|[Methods](https://developer.android.com/reference/android/os/CpuHeadroomParams#pubmethods)\|[Inherited Methods](https://developer.android.com/reference/android/os/CpuHeadroomParams#inhmethods)  

# CpuHeadroomParams

*** ** * ** ***

[Kotlin](https://developer.android.com/reference/kotlin/android/os/CpuHeadroomParams "View this page in Kotlin")\|Java

`
public

final

class
CpuHeadroomParams
`  
`

extends `[Object](https://developer.android.com/reference/java/lang/Object)`


``


`

|---|------------------------------|
| [java.lang.Object](https://developer.android.com/reference/java/lang/Object) ||
| ↳ | android.os.CpuHeadroomParams |

<br />

*** ** * ** ***

Headroom request params used by[SystemHealthManager.getCpuHeadroom(CpuHeadroomParams)](https://developer.android.com/reference/android/os/health/SystemHealthManager#getCpuHeadroom(android.os.CpuHeadroomParams)).

This class is immutable and one should use the[Builder](https://developer.android.com/reference/android/os/CpuHeadroomParams.Builder)to build a new instance.

## Summary

|                                                     ### Nested classes                                                     ||
|----------|------------------------------------------------------------------------------------------------------------------|
| ` class` | [CpuHeadroomParams.Builder](https://developer.android.com/reference/android/os/CpuHeadroomParams.Builder) <br /> |

|                                                                                                              ### Constants                                                                                                               ||
|-------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| `int` | [CPU_HEADROOM_CALCULATION_TYPE_AVERAGE](https://developer.android.com/reference/android/os/CpuHeadroomParams#CPU_HEADROOM_CALCULATION_TYPE_AVERAGE) The headroom calculation type bases on average value over a specified window. |
| `int` | [CPU_HEADROOM_CALCULATION_TYPE_MIN](https://developer.android.com/reference/android/os/CpuHeadroomParams#CPU_HEADROOM_CALCULATION_TYPE_MIN) The headroom calculation type bases on minimum value over a specified window.         |

|                                                                                                                                                                       ### Public methods                                                                                                                                                                        ||
|--------------------------------------------------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| ` boolean`                                                                                                   | ` `[equals](https://developer.android.com/reference/android/os/CpuHeadroomParams#equals(java.lang.Object))`(`[Object](https://developer.android.com/reference/java/lang/Object)` o) ` Indicates whether some other object is "equal to" this one. |
| ` int`                                                                                                       | ` `[getCalculationType](https://developer.android.com/reference/android/os/CpuHeadroomParams#getCalculationType())`() ` Gets the headroom calculation type.                                                                                       |
| ` long`                                                                                                      | ` `[getCalculationWindowMillis](https://developer.android.com/reference/android/os/CpuHeadroomParams#getCalculationWindowMillis())`() ` Gets the headroom calculation window size in milliseconds.                                                |
| ` int[]`                                                                                                     | ` `[getTids](https://developer.android.com/reference/android/os/CpuHeadroomParams#getTids())`() ` Gets the TIDs to track.                                                                                                                         |
| ` int`                                                                                                       | ` `[hashCode](https://developer.android.com/reference/android/os/CpuHeadroomParams#hashCode())`() ` Returns a hash code value for the object.                                                                                                     |
| ` `[CpuHeadroomParams.Builder](https://developer.android.com/reference/android/os/CpuHeadroomParams.Builder) | ` `[toBuilder](https://developer.android.com/reference/android/os/CpuHeadroomParams#toBuilder())`() ` Returns a new builder with the same values as this object.                                                                                  |
| ` `[String](https://developer.android.com/reference/java/lang/String)                                        | ` `[toString](https://developer.android.com/reference/android/os/CpuHeadroomParams#toString())`() ` Returns a string representation of the object.                                                                                                |

| ### Inherited methods |
|-----------------------|---|
| From class` `[java.lang.Object](https://developer.android.com/reference/java/lang/Object)` ` |--------------------------------------------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------| | ` `[Object](https://developer.android.com/reference/java/lang/Object)          | ` `[clone](https://developer.android.com/reference/java/lang/Object#clone())`() ` Creates and returns a copy of this object.                                                                                                                                                      | | ` boolean`                                                                     | ` `[equals](https://developer.android.com/reference/java/lang/Object#equals(java.lang.Object))`(`[Object](https://developer.android.com/reference/java/lang/Object)` obj) ` Indicates whether some other object is "equal to" this one.                                           | | ` void`                                                                        | ` `[finalize](https://developer.android.com/reference/java/lang/Object#finalize())`() ` Called by the garbage collector on an object when garbage collection determines that there are no more references to the object.                                                          | | ` final `[Class](https://developer.android.com/reference/java/lang/Class)`<?>` | ` `[getClass](https://developer.android.com/reference/java/lang/Object#getClass())`() ` Returns the runtime class of this`Object`.                                                                                                                                                | | ` int`                                                                         | ` `[hashCode](https://developer.android.com/reference/java/lang/Object#hashCode())`() ` Returns a hash code value for the object.                                                                                                                                                 | | ` final void`                                                                  | ` `[notify](https://developer.android.com/reference/java/lang/Object#notify())`() ` Wakes up a single thread that is waiting on this object's monitor.                                                                                                                            | | ` final void`                                                                  | ` `[notifyAll](https://developer.android.com/reference/java/lang/Object#notifyAll())`() ` Wakes up all threads that are waiting on this object's monitor.                                                                                                                         | | ` `[String](https://developer.android.com/reference/java/lang/String)          | ` `[toString](https://developer.android.com/reference/java/lang/Object#toString())`() ` Returns a string representation of the object.                                                                                                                                            | | ` final void`                                                                  | ` `[wait](https://developer.android.com/reference/java/lang/Object#wait(long,%20int))`(long timeoutMillis, int nanos) ` Causes the current thread to wait until it is awakened, typically by being*notified* or*interrupted*, or until a certain amount of real time has elapsed. | | ` final void`                                                                  | ` `[wait](https://developer.android.com/reference/java/lang/Object#wait(long))`(long timeoutMillis) ` Causes the current thread to wait until it is awakened, typically by being*notified* or*interrupted*, or until a certain amount of real time has elapsed.                   | | ` final void`                                                                  | ` `[wait](https://developer.android.com/reference/java/lang/Object#wait())`() ` Causes the current thread to wait until it is awakened, typically by being*notified* or*interrupted*.                                                                                             | ||

## Constants

### CPU_HEADROOM_CALCULATION_TYPE_AVERAGE

Added in[API level 36](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)  

```
public static final int CPU_HEADROOM_CALCULATION_TYPE_AVERAGE
```

The headroom calculation type bases on average value over a specified window.

<br />

Constant Value: 1 (0x00000001)  

### CPU_HEADROOM_CALCULATION_TYPE_MIN

Added in[API level 36](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)  

```
public static final int CPU_HEADROOM_CALCULATION_TYPE_MIN
```

The headroom calculation type bases on minimum value over a specified window.

<br />

Constant Value: 0 (0x00000000)

## Public methods

### equals

Added in[API level 36](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)  

```
public boolean equals (Object o)
```

Indicates whether some other object is "equal to" this one.

The`equals`method implements an equivalence relation on non-null object references:

- It is*reflexive* : for any non-null reference value`x`,`x.equals(x)`should return`true`.
- It is*symmetric* : for any non-null reference values`x`and`y`,`x.equals(y)`should return`true`if and only if`y.equals(x)`returns`true`.
- It is*transitive* : for any non-null reference values`x`,`y`, and`z`, if`x.equals(y)`returns`true`and`y.equals(z)`returns`true`, then`x.equals(z)`should return`true`.
- It is*consistent* : for any non-null reference values`x`and`y`, multiple invocations of`x.equals(y)`consistently return`true`or consistently return`false`, provided no information used in`equals`comparisons on the objects is modified.
- For any non-null reference value`x`,`x.equals(null)`should return`false`.

An equivalence relation partitions the elements it operates on into*equivalence classes*; all the members of an equivalence class are equal to each other. Members of an equivalence class are substitutable for each other, at least for some purposes.

<br />

|                            Parameters                             ||
|-----|--------------------------------------------------------------|
| `o` | `Object`: the reference object with which to compare. <br /> |

|                                         Returns                                          ||
|-----------|-------------------------------------------------------------------------------|
| `boolean` | `true`if this object is the same as the obj argument;`false`otherwise. <br /> |

### getCalculationType

Added in[API level 36](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)  

```
public int getCalculationType ()
```

Gets the headroom calculation type.

This will return the default value chosen by the device if not set.

<br />

|                                                                                                                                                         Returns                                                                                                                                                          ||
|-------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| `int` | Value is[CPU_HEADROOM_CALCULATION_TYPE_MIN](https://developer.android.com/reference/android/os/CpuHeadroomParams#CPU_HEADROOM_CALCULATION_TYPE_MIN), or[CPU_HEADROOM_CALCULATION_TYPE_AVERAGE](https://developer.android.com/reference/android/os/CpuHeadroomParams#CPU_HEADROOM_CALCULATION_TYPE_AVERAGE) <br /> |

### getCalculationWindowMillis

Added in[API level 36](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)  

```
public long getCalculationWindowMillis ()
```

Gets the headroom calculation window size in milliseconds.

This will return the default value chosen by the device if not set.

<br />

|    Returns     ||
|--------|--------|
| `long` | <br /> |

### getTids

Added in[API level 36](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)  

```
public int[] getTids ()
```

Gets the TIDs to track.

This will return a copy of the TIDs in the params, or null if the params is not set.

<br />

|     Returns     ||
|---------|--------|
| `int[]` | <br /> |

### hashCode

Added in[API level 36](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)  

```
public int hashCode ()
```

Returns a hash code value for the object. This method is supported for the benefit of hash tables such as those provided by[HashMap](https://developer.android.com/reference/java/util/HashMap).

The general contract of`hashCode`is:

- Whenever it is invoked on the same object more than once during an execution of a Java application, the`hashCode`method must consistently return the same integer, provided no information used in`equals`comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application.
- If two objects are equal according to the[equals](https://developer.android.com/reference/java/lang/Object#equals(java.lang.Object))method, then calling the`hashCode`method on each of the two objects must produce the same integer result.
- It is*not* required that if two objects are unequal according to the[equals](https://developer.android.com/reference/java/lang/Object#equals(java.lang.Object))method, then calling the`hashCode`method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hash tables.

<br />

<br />

|                     Returns                      ||
|-------|-------------------------------------------|
| `int` | a hash code value for this object. <br /> |

### toBuilder

Added in[API level 36](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)  

```
public CpuHeadroomParams.Builder toBuilder ()
```

Returns a new builder with the same values as this object.

<br />

|                                                                    Returns                                                                    ||
|-----------------------------------------------------------------------------------------------------------|------------------------------------|
| [CpuHeadroomParams.Builder](https://developer.android.com/reference/android/os/CpuHeadroomParams.Builder) | This value cannot be`null`. <br /> |

### toString

Added in[API level 36](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)  

```
public String toString ()
```

Returns a string representation of the object.

<br />

|                                                      Returns                                                      ||
|--------------------------------------------------------------------|-----------------------------------------------|
| [String](https://developer.android.com/reference/java/lang/String) | a string representation of the object. <br /> |